#include "main.h"
#include <os.h>
#include "graphics.h"
#include "n2DLib.h"

#include <stdio.h>
#include <stdlib.h>

/*
 *
 * 	HELI-COPT3RS
 * 	RECREATION
 *
 * 	FOR GAMEBLABLA'S WRAPPER
 * 	ORIGINALLY PROGRAMMED FOR 3DO
 *
 */

/* 
    This program is free software. It comes without any warranty, to
    the extent permitted by applicable law. You can redistribute it
    and/or modify it under the terms of the Do What The Fuck You Want
    To Public License, Version 2, as published by Sam Hocevar. 
    See http://www.wtfpl.net/ for more details. 
*/

short helice_frame = 0;
short helice_time = 0;

// Alien position
short Player_X = 150;
short Player_Y = 196;

// Animation
unsigned char Frame_player	 = 0;
unsigned char Facing_player	 = 0;
unsigned char Max_Frame_player = 3;
unsigned char Delay_Frame_player = 0;
unsigned char state_player = 0;
char time_speed = 0;
char speed_player = 0;
short helice_diff = -2;

//Controls
unsigned char A_state = 0;
unsigned char A_time = 0;
unsigned char begin = 0;
unsigned char death = 0;
char platform[2];

short score = 0, highscore = 0;
short platforme_x_left[3];
short platforme_x_right[3];
short platforme_y[3];
short cloud_x[2], cloud_y[2];
short bottom_y = 192;
short gameover_x = -128;
short number_x[3] , number_y[3];

short hammer_x[5], hammer_y[5];
short hammer_anim_time = 0 , hammer_frame = 0 , hammer_facing = 0;
short hammer_collisions[5];


unsigned char game_mode;

int main ( int argc, char* argv[] )
{
	unsigned char done = 0;
	
	enable_relative_paths(argv);
	initBuffering();
	Load_score();
	/*Init_sound();*/
	game_mode = 0;

	while(!done)
	{
		
		if (isKeyPressed(KEY_NSPIRE_ESC)) done = 1;	
		switch(game_mode)
		{
			case 0:
				InitializeGame();
			break;
			case 1:
				GameLoop();
			break;
		}
					
		updateScreen();
	}
		
	Save_score();
	deinitBuffering();
		
	return 0;
}

static inline void load_game_memory()
{
	game_mode = 1;
}

static void InitializeGame()
{
	
	load_game_memory();
	
	/*Init_Audio();*/
	Reset_game();
	
	game_mode = 1;
}

static void GameLoop()
{
	
	drawSprite(background, 0, 0);

    Show_Bottom_back();
	
	A_button();
	
	Collisions();
	Platforms_manage();
	Show_Clouds();
	Show_Hammer();
	
	Show_platforme_gauche_0();
	Show_platforme_gauche_1();
	Show_platforme_droite_0();
	Show_platforme_droite_1();
	
	Show_GameOver();
	
	Show_Player();
	Show_helices();
	
	Show_score();

	if (begin == 1) Move_player();

	Gameplay();
}

inline void Show_platforme_gauche_0()
{
	drawSprite(bar_gauche, platforme_x_right[0], platforme_y[0]);
}

inline void Show_platforme_gauche_1()
{
	drawSprite(bar_gauche, platforme_x_right[1], platforme_y[1]);
}

inline void Show_platforme_droite_0()
{
	drawSprite(bar_droite, platforme_x_left[0], platforme_y[0]);
}

inline void Show_platforme_droite_1()
{
	drawSprite(bar_droite, platforme_x_left[1], platforme_y[1]);
}

static inline void Show_GameOver()
{	
	switch(state_player)
	{
		case 2:
			drawSprite(gameover, gameover_x, 24);
			drawSprite(result, gameover_x-16, 96);
			drawSprite(try,gameover_x-18, 184);
			if (gameover_x < 96) gameover_x = gameover_x + 6;
		break;
		default:
			gameover_x = -320;
			if (gameover_x == -320)
			{
				drawSprite(gameover, gameover_x, 24);
				drawSprite(result, gameover_x-16, 96);
				drawSprite(try,gameover_x-18, 184);
			}
		break;
	}
	
}

static inline void Show_score()
{
	Rect score_spr[4];
	
	switch(death)
	{
		case 0:
		score_spr[0].w = 16;
		score_spr[0].h = 16;
		score_spr[0].x = (score/10)%10 * (score_spr[0].w);
		score_spr[0].y = 0;
		drawSpritePart(score_sprite, 144, 8, &score_spr[0]);
		
		score_spr[1].w = 16;
		score_spr[1].h = 16;
		score_spr[1].x = (score)%10 * (score_spr[1].w);
		score_spr[1].y = 0;
		drawSpritePart(score_sprite, 160, 8, &score_spr[1]);
		break;
		case 2:
		score_spr[0].w = 16;
		score_spr[0].h = 16;
		score_spr[0].x = (score/10)%10 * (score_spr[0].w);
		score_spr[0].y = 0;
		drawSpritePart(score_sprite, gameover_x+59, 101, &score_spr[0]);
		
		score_spr[1].w = 16;
		score_spr[1].h = 16;
		score_spr[1].x = (score)%10 * (score_spr[1].w);
		score_spr[1].y = 0;
		drawSpritePart(score_sprite, gameover_x+75, 101, &score_spr[1]);
		
		score_spr[2].w = 16;
		score_spr[2].h = 16;
		score_spr[2].x = (highscore/10)%10 * (score_spr[2].w);
		score_spr[2].y = 0;
		drawSpritePart(score_sprite, gameover_x+59, 133, &score_spr[2]);
		
		score_spr[3].w = 16;
		score_spr[3].h = 16;
		score_spr[3].x = (highscore)%10 * (score_spr[3].w);
		score_spr[3].y = 0;
		drawSpritePart(score_sprite, gameover_x+75, 133, &score_spr[3]);
		break;
	}
	

}

static inline void Add_score()
{
	score = score + 1;
}

static inline void Show_helices()
{
	static short X_helice;

	helice_time=helice_time+1;
	
	Rect hammer_spr;
	
	hammer_spr.w = 24;
	hammer_spr.h = 12;
	hammer_spr.x = helice_frame * (hammer_spr.w);
	hammer_spr.y = 0;
	drawSpritePart(helice, X_helice, Player_Y, &hammer_spr);
	
	X_helice = -320;
	
	if (death == 0)
	{
			switch(begin)
			{
				case 1:
					switch(Facing_player)
					{
						case 0:
						X_helice = Player_X+4;
						
						if (helice_frame > 2) helice_frame = 0;
						
						if (helice_time > 2)
						{
							helice_frame = helice_frame + 1;
							if (helice_frame > 2) helice_frame = 0;
							helice_time = 0;
						}
						break;
						case 4:
						X_helice = Player_X-7;
						
						if (helice_frame < 3) helice_frame = 2;
						
						if (helice_time > 2)
						{
							helice_frame = helice_frame + 1;
							if (helice_frame > 5) helice_frame = 3;
							helice_time = 0;
						}
						break;
					}
				break;
				
				case 0:
				X_helice = Player_X-2;
				helice_frame = 6;
				break;
			}
	}

}

/*
static inline void Init_Audio()
{
	Init_sound();
	Load_SFX(1, "gfx/smack.wav");
	Load_SFX(2, "gfx/switch.wav");
}
*/

static inline void play_smack()
{
	/*Play_SFX(1);*/
}

static inline void play_switch()
{
	/*Play_SFX(2);*/
}

static inline void Reset_game()
{
	platforme_x_right[0] = rand_a_b(100,210);
	platforme_x_left[0] = platforme_x_right[0] - 296 - rand_a_b(32,64);
	platforme_x_right[1] = rand_a_b(100,210);
	platforme_x_left[1] = platforme_x_right[1] - 296 - rand_a_b(32,64);
	
	platforme_y[0] = 40;
	platforme_y[1] = -140;
	cloud_x[0] = rand_a_b(10,60);
	cloud_x[1] = rand_a_b(185,220);
	cloud_y[0] = rand_a_b(-128,-220);
	cloud_y[1] = rand_a_b(-128,-220);
	
	Player_X = 150;
	Player_Y = 196;
	bottom_y = 192;
	
	Frame_player	 = 0;
	Facing_player	 = 0;
	Max_Frame_player = 3;
	Delay_Frame_player	 = 0;
	state_player = 0;
	time_speed = 0;
	speed_player = 0;

	A_state = 0;
	A_time = 0;
	begin = 0;
	death = 0;
	
	helice_frame = 0;
	helice_time = 0;
	
	gameover_x = -128;
	score = 0;

	platform[0] = 0;
	platform[1] = 0;
}

static inline void Gameplay()
{
	unsigned char i;

	if (A_state > 2)
	{
		if (begin == 0 && death == 0) 
		{
			A_state = 3;
			A_time = 3;
			begin = 1;
		}
		if (state_player == 2 && death == 2) 
		{
			A_state = 3;
			A_time = 3;
			Reset_game();
		}
	}


	if (isKeyPressed(KEY_NSPIRE_MENU)) Trigger_Death();
	
	for (i=0; i<2; i++)
	{
		if (platform[i] < 1 && Player_Y<platforme_y[i])
		{
			platform[i] = 1;
			Add_score();
		}
	}
	
	switch(death)
	{
		case 1:
			Frame_player = 0;
			state_player = 1;
			Delay_Frame_player = 0;
			Facing_player = 6;
			if (score > highscore) highscore=score;
			death = 2;
		break;
		case 2:
			if (Player_Y-5 > bottom_y)
			{
				state_player = 2;
			}
			else
			{
				if (bottom_y > 199)
				{
					bottom_y = bottom_y - 8;
					platforme_y[0] = platforme_y[0] - 8;
					platforme_y[1] = platforme_y[1] - 8;
					cloud_y[0] = cloud_y[0] - 8;
					cloud_y[1] = cloud_y[1] - 8;
				}
				else if (bottom_y < 200)
				{
					Player_Y = Player_Y + 5;
				}
			}
		break;
		
	}

	
}

static inline void Collisions()
{
	unsigned char i;

	//Handle Collisions between 'barres' and the 'Player'
	for (i=0; i<2; i++)
	{
		if ((Player_X + 18 > platforme_x_right[i]) && (Player_X+2 < platforme_x_right[i] + 256) && (Player_Y + 24 > platforme_y[i]) && (Player_Y+4 < platforme_y[i] + 16)) 
			Trigger_Death();
		else if ((Player_X + 18 > platforme_x_left[i]) && (Player_X+2 < platforme_x_left[i] + 256) && (Player_Y + 24 > platforme_y[i]) && (Player_Y+4 < platforme_y[i] + 16)) 
			Trigger_Death();
			
		if ( (Player_X + 18 > hammer_x[i]) && (Player_X+2 < hammer_x[i] + hammer_collisions[1]) && (Player_Y + 24 > hammer_y[i]) && (Player_Y+4 < hammer_y[i]+hammer_collisions[3]) )
		{
			Trigger_Death();
		}
	}
	
	for (i=2; i<5; i++)
	{
		if ( (Player_X + 18 > hammer_x[i]) && (Player_X+2 < hammer_x[i] + hammer_collisions[1]) && (Player_Y + 24 > hammer_y[i]) && (Player_Y+4 < hammer_y[i]+hammer_collisions[3]) )
		{
			Trigger_Death();
		}
	}
	
	//Between Hammers and the Player
	
	switch(hammer_frame)
	{
		case 0:
		hammer_collisions[0] = 0;
		hammer_collisions[2] = 0;
		hammer_collisions[1] = 21;
		hammer_collisions[3] = 30;
		break;
		case 1:
		hammer_collisions[0] = 0;
		hammer_collisions[2] = 0;
		hammer_collisions[1] = 22;
		hammer_collisions[3] = 32;
		break;
		case 2:
		hammer_collisions[0] = 0;
		hammer_collisions[2] = 0;
		hammer_collisions[1] = 34;
		hammer_collisions[3] = 32;
		break;
		case 3:
		hammer_collisions[0] = 0;
		hammer_collisions[2] = 0;
		hammer_collisions[1] = 42;
		hammer_collisions[3] = 32;
		break;
		case 4:
		hammer_collisions[0] = 0;
		hammer_collisions[2] = 0;
		hammer_collisions[1] = 48;
		hammer_collisions[3] = 30;
		break;
	}
	
	
}

static inline void Platforms_manage()
{
	unsigned char i;
	
	for (i=0; i<2; i++)
	{
		if (begin == 1) 
		{
			platforme_y[i] = platforme_y[i] + 1;
		}
		
		if (platforme_y[i] > 240)
		{
			platform[i] = 0;
			platforme_y[i] = -32;
			platforme_x_right[i] = rand_a_b(100,300);
			platforme_x_left[i] = platforme_x_right[i] - 296 - rand_a_b(32,64);
		}
	}
	
	if ((platforme_y[1] < -15) && (platforme_y[0]-platforme_y[1] < 180)) 
		platforme_y[1] = platforme_y[1] - 60;
	if ((platforme_y[0] < -15) && (platforme_y[1]-platforme_y[0] < 180)) 
		platforme_y[0] = platforme_y[0] - 60;
}

static inline void Show_Bottom_back()
{
	if (bottom_y < 350) 
	{
		drawSprite(back , 0, bottom_y);
	}
	
	if (begin == 1 && bottom_y < 480) 
	{
		bottom_y = bottom_y + 1;
	}
}

static inline void Show_Clouds()
{
	unsigned char i;

	drawSprite(cloud, cloud_x[0], cloud_y[0]);
	drawSprite(cloud, cloud_x[1], cloud_y[1]);

	if (begin == 1) 
	{
		for (i=0; i<2; i++) 
		{
			cloud_y[i] = cloud_y[i] + 1;
		}
	}
	
	if (cloud_y[0] > 240)
	{
		cloud_x[0] = rand_a_b(10,60);
		cloud_y[0] = rand_a_b(-160,-220);
	}
	
	if (cloud_y[1]  > 240)
	{
		cloud_x[1] = rand_a_b(185,220);
		cloud_y[1] = rand_a_b(-128,-220);
	}
}

static inline void Show_Hammer()
{
	Rect hammer_spr;
	
	hammer_spr.w = 48;
	hammer_spr.h = 32;
	hammer_spr.x = (hammer_frame) * (hammer_spr.w);
	hammer_spr.y = 0;
	
	drawSpritePart(hammer, hammer_x[0], hammer_y[0], &hammer_spr);
	drawSpritePart(hammer, hammer_x[1], hammer_y[1], &hammer_spr);
	drawSpritePart(hammer, hammer_x[2], hammer_y[2], &hammer_spr);
	drawSpritePart(hammer, hammer_x[3], hammer_y[3], &hammer_spr);
	
	hammer_x[0] = 226+platforme_x_left[0];
	hammer_x[1] = platforme_x_right[0]-6;
	hammer_x[2] = 226+platforme_x_left[1];
	hammer_x[3] = platforme_x_right[1]-6;
	
	hammer_y[0] = platforme_y[0]+12;
	hammer_y[1] = platforme_y[0]+12;
	hammer_y[2] = platforme_y[1]+12;
	hammer_y[3] = platforme_y[1]+12;
	
	// This part animates the Hammer and it goes from right to left and etc... (Refer to hammer_spr.cel)
	
	switch(hammer_facing)
	{
		case 0:
		hammer_anim_time = hammer_anim_time + 1;
		if (hammer_anim_time > 9)
		{
			hammer_frame = hammer_frame + 1;
				if (hammer_frame > 3)
				{
					hammer_frame = 4;
					hammer_facing = 1;
				}
			hammer_anim_time = 0;
		}
		break;
		case 1:
		hammer_anim_time = hammer_anim_time + 1;
		if (hammer_anim_time > 9)
		{
			hammer_frame = hammer_frame - 1;
				if (hammer_frame < 1)
				{
					hammer_frame = 0;
					hammer_facing = 0;
				}
			hammer_anim_time = 0;
		}
		break;
	}
	

}

static inline void Show_Player()
{
	Rect character_spr;
	
	character_spr.w = 20;
	character_spr.h = 24;
	character_spr.x = (Frame_player + Facing_player) * (character_spr.w);
	character_spr.y = 0;
	drawSpritePart(character, Player_X, Player_Y, &character_spr);
	
	if (Player_X > 320-16) Trigger_Death();
	if (Player_X < 0+4) Trigger_Death();
	
	if (begin == 1 && Player_Y > 150)
	{
		Player_Y = Player_Y - 1;
	}

	// If Player is falling
	if (state_player == 1)
	{
		Delay_Frame_player = Delay_Frame_player + 1;
		if (Delay_Frame_player > 2)
		{
			Frame_player = Frame_player + 1;
			if (Frame_player > 5) Frame_player = 5;
			Delay_Frame_player = 0;
		}
	}
	
}

static inline void Move_player()
{
	switch(Facing_player)
	{
		case 0:
		if (A_state == 1) 
		{
			play_switch();
			Facing_player = 4;
			A_time = 0;
			A_state = 2;
			time_speed = 0;
			speed_player = 0;
		}
		Player_X = Player_X + speed_player;
		break;
		case 4:
		if (A_state == 1) 
		{
			play_switch();
			Facing_player = 0;
			A_time = 0;
			A_state = 2;
			time_speed = 0;
			speed_player = 0;
		}
		Player_X = Player_X - speed_player;
		break;
		
	}
	

	time_speed = time_speed + 1;
	switch(time_speed)
	{
		case 3:
			speed_player = speed_player + 1;
			time_speed = 0;
		break;
		case 4:
		case 5:
		case 6:
			speed_player = speed_player + 1;
			time_speed = 0;
		break;
		case 7:
			speed_player = speed_player + 1;
			if (speed_player > 5) speed_player = 5;
			time_speed = 0;
		break;
	}

	switch(speed_player)
	{
		case 0:
			Frame_player = 0;
		break;
		case 1:
			Frame_player = 1;
		break;
		case 2:
			Frame_player = 2;
		break;
		case 3:
		case 4:
			Frame_player = 3;
		break;
	}
	
}

static inline void A_button()
{
	switch(A_state)
	{
		case 0:
		if (isKeyPressed(KEY_NSPIRE_TAB)==1)
		{
			A_state = 1;
			A_time = 0;
		}
		break;
		case 1:
		A_time = A_time + 1;
		if (A_time > 1)
		{
			A_state = 2;
			A_time = 0;
		}
		break;	
		case 2:
		if (isKeyPressed(KEY_NSPIRE_TAB)==0)
		{
			A_state = 3;
			A_time = 0;
		}
		break;
		case 3:
		A_time = A_time + 1;
		if (A_time > 1)
		{
			A_state = 0;
			A_time = 0;
		}
		break;
	}
	
}

static inline void Trigger_Death()
{
	if (death == 0 && begin == 1)
	{
		play_smack();
		begin = 0;
		death = 1;
	}
}


// Used for random coordinate for the clouds
static inline short rand_a_b(short a, short b)
{
    return rand()%(b-a) +a;
}


static inline void Load_score()
{
	unsigned long score_keep[2];
	FILE* file;
	
    file = fopen("./heli_score.tns", "r+");
	
	if (file)
    {
		score_keep[0] = fgetc(file);
		score_keep[1] = fgetc(file);
		fclose(file);
		
		highscore = (score_keep[1]*10) + score_keep[0];
	}
	else
	{
		fclose(file);
	}
}

static inline void Save_score()
{
	unsigned long score_keep[2];
	FILE* file;
	
	score_keep[0] = highscore % 10;
	score_keep[1] = (highscore / 10) % 10;
	
	file = fopen("./heli_score.tns", "w+");
	
    fputc( score_keep[0], file );
	fputc( score_keep[1], file );		
	fclose(file);
}
